LPARAM lcDBC
LOCAL lcPath,lcAlias,liCount,liIDT,liIDF,luValue,lcErr,llErr,luValueO
LOCAL ARRAY xxa(1),xxb(1)

CLEAR
#INCLUDE "dbc.h"

lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)
SET PROCEDURE TO (lcPath+"dfo.prg")

lcAlias=SYS(2015)


lcDBC=IIF(EMPTY(lcDBC),HOME(2)+"\Tastrade\Data\tastrade.dbc",lcDBC)

lcErr=ON("ERROR")
ON Error llErr=.T.
USE (lcDBC) ALIAS (lcAlias) IN 0
IF !EMPTY(lcErr)
   ON ERROR &lcErr.
ELSE
   ON ERROR
ENDIF

IF llErr
   WAIT WIND "Can not open DBC file."
   RETURN
ENDIF

* Get all parts of database (inclusive of database)
liCount=DBC_EnumObjects(lcAlias,_DBC_DataBase,"",@xxa)
=PrintObjects(liCount,@xxa)

* Get Stored Procedure
=DBC_GetSP(lcAlias,_DBC_SP_TSource,@luValue)
?luValue
=DBC_GetSP(lcAlias,_DBC_SP_TFXP,@luValue)
?luValue

* Set Stored Procedure
*!*	=DBC_SetSP(lcAlias,_DBC_SP_TSource,@luValue)
*!*	=DBC_SetSP(lcAlias,_DBC_SP_TFXP,@luValue)


* Get all tables
liCount=DBC_EnumObjects(lcAlias,_DBC_Table,"",@xxa)
=PrintObjects(liCount,@xxa)

* Get all views
liCount=DBC_EnumObjects(lcAlias,_DBC_View,"",@xxa)
=PrintObjects(liCount,@xxa)

* Get all Connections
liCount=DBC_EnumObjects(lcAlias,_DBC_Connection,"",@xxa)
=PrintObjects(liCount,@xxa)


liIDT=DBC_GetIDObject(lcAlias,_DBC_Table,"products")

* Get all Fields for table/view
liCount=DBC_EnumObjects(lcAlias,_DBC_Field,liIDT,@xxa)
=PrintObjects(liCount,@xxa)

* Get all properties for Field
?"products."+xxa(1,2)
liCount=DBC_EnumProperty(lcAlias,xxa(1,1),@xxb)
=PrintProperties(liCount,@xxb)

* xxa(1,1) - ID of Field
* xxb(2,1) - ID of Property, equal to _DBCID_Comment (in this case)

* Get property 
=DBC_GetProperty(lcAlias,xxa(1,1),xxb(2,1),@luValueO)
?"Current value: products."+xxa(1,2)+"-"+DBC_FormatProperty(xxb(2,1)),luValueO

* Set property
=DBC_SetProperty(lcAlias,xxa(1,1),xxb(2,1),"New comment"+SYS(2015))
=DBC_GetProperty(lcAlias,xxa(1,1),xxb(2,1),@luValue)
?"New value: products."+xxa(1,2)+"-"+DBC_FormatProperty(xxb(2,1)),luValue

* Clear property
=DBC_ClearProperty(lcAlias,xxa(1,1),xxb(2,1))
=DBC_GetProperty(lcAlias,xxa(1,1),xxb(2,1),@luValue)
?"Droped: products."+xxa(1,2)+"-"+DBC_FormatProperty(xxb(2,1)),luValue

* Restore property
=DBC_SetProperty(lcAlias,xxa(1,1),xxb(2,1),@luValueO)
=DBC_GetProperty(lcAlias,xxa(1,1),xxb(2,1),@luValue)
?"Restored value: products."+xxa(1,2)+"-"+DBC_FormatProperty(xxb(2,1)),luValue

* Get all Relations for table/view
liCount=DBC_EnumObjects(lcAlias,_DBC_Relation,liIDT,@xxa)
=PrintObjects(liCount,@xxa)

* Get RI Info for relation
=DBC_RIInfo(lcAlias,xxa(1,1),@luValue)
?"products."+xxa(1,2),luValue


* Get all Indexes for table/view
liCount=DBC_EnumObjects(lcAlias,_DBC_Index,liIDT,@xxa)
=PrintObjects(liCount,@xxa)


USE IN (lcAlias)




PROCEDURE PrintObjects(liCount,laArray)
LOCAL lii
?PADR("ID",11)+" "+"Name"
FOR lii=1 TO liCount
    ?STR(laArray(lii,1),11)+" "+laArray(lii,2)
NEXT
?


PROCEDURE PrintProperties(liCount,laArray)
LOCAL lii,lcType
?PADR("ID",11)+" "+PADR("Name",30)+" "+"Value"
FOR lii=1 TO liCount
    lcType=TYPE("laArray(lii,2)")
    ?STR(laArray(lii,1),11)+" "+PADR(DBC_FormatProperty(laArray(lii,1)),30)+" "+;
      IIF(ISNULL(laArray(lii,2)),".NULL.",;
      IIF(lcType="N",STR(laArray(lii,2),17),;
      IIF(lcType="C",laArray(lii,2),;
      IIF(lcType="L",IIF(laArray(lii,2),".T.",".F."),"Unknown"))))
NEXT
?
